/*  miniboxtk - small GUI toolkit/widget system
    Copyright (C) 2022  Tibor 'Igor2' Palinkas

    (Supported by NLnet NGI0 PET Fund in 2022)

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

    Contact:
      Project page: http://repo.hu/projects/miniboxtk
      contact lead developer: http://www.repo.hu/projects/miniboxtk/contact.html
*/

#ifndef LIBMBTK_BACKEND_COMMON_FD_WATCH
#define LIBMBTK_BACKEND_COMMON_FD_WATCH

#include <genvector/vtl0.h>
#include "../../global_typedefs.h"
#include "../../event.h"

typedef struct {
	vtl0_t rd, wr;
	long last; /* highest numbered fd ever */
} mbtk_watch_fd_t;

void mbtk_watch_fd_set(mbtk_watch_fd_t *ctx, int fd, int for_read, int for_write);

int mbtk_watch_fd_select(mbtk_watch_fd_t *ctx, mbtk_event_t *dst, long *usec, mbtk_window_t *win);

void mbtk_watch_fd_uninit(mbtk_watch_fd_t *ctx);

#endif
