/*  miniboxtk - small GUI toolkit/widget system
    Copyright (C) 2022  Tibor 'Igor2' Palinkas

    (Supported by NLnet NGI0 PET Fund in 2022)

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

    Contact:
      Project page: http://repo.hu/projects/miniboxtk
      contact lead developer: http://www.repo.hu/projects/miniboxtk/contact.html
*/

static void mbtk_test_window_set_title(mbtk_window_t *win, const char *title)
{
	test_win_t *tw = (test_win_t *)win;
	printf("window_set_title: W%d, '%s'\n", tw->id, title);
}

static mbtk_window_t *mbtk_test_window_new(mbtk_display_t *disp, mbtk_window_type_t type, const char *title, long x, long y, long w, long h)
{
	test_display_t *td = (test_display_t *)disp;
	mbtk_window_t *win = calloc(sizeof(mbtk_window_t), 1);
	test_win_t *tw = (test_win_t *)win;

	tw->id = ++td->win_ids;
	tw->x = x; tw->y = y;
	tw->w = w; tw->h = h;

	printf("window_new: %d, '%s', %ld;%ld %ld;%ld -> W%d\n", type, title, x, y, w, h, tw->id);

	return win;
}

static void mbtk_test_window_close(mbtk_window_t *win)
{
	test_win_t *tw = (test_win_t *)win;
	printf("window_close: W%d\n", tw->id);
	tw->id = -tw->id;
}

static mbtk_window_t *mbtk_test_win2render_win(mbtk_window_t *win)
{
	return win;
}

static void mbtk_test_window_raise(mbtk_window_t *win)
{
	test_win_t *tw = (test_win_t *)win;
	printf("window_raise: W%d\n", tw->id);
}

static void mbtk_test_window_hide(mbtk_window_t *win)
{
	test_win_t *tw = (test_win_t *)win;
	printf("window_hide: W%d\n", tw->id);
}

static void mbtk_test_window_show(mbtk_window_t *win)
{
	test_win_t *tw = (test_win_t *)win;
	printf("window_show: W%d\n", tw->id);
}

static void mbtk_test_window_transient4(mbtk_window_t *win, mbtk_window_t *tr_for)
{
	test_win_t *tw = (test_win_t *)win;
	test_win_t *tw4 = (test_win_t *)tr_for;

	printf("window_transient4: W%d, W%d\n", tw->id, tw4->id);
}

static void mbtk_test_window_set_min_size(mbtk_window_t *win, long w, long h)
{
	test_win_t *tw = (test_win_t *)win;
	printf("window_set_min_size: W%d, %ld;%ld\n", tw->id, w, h);
}

static void mbtk_test_window_set_size(mbtk_window_t *win, long w, long h)
{
	test_win_t *tw = (test_win_t *)win;
	tw->w = w; tw->h = h;
	printf("window_set_size: W%d, %ld;%ld\n", tw->id, w, h);
}

