/*  miniboxtk - small GUI toolkit/widget system
    Copyright (C) 2022  Tibor 'Igor2' Palinkas

    (Supported by NLnet NGI0 PET Fund in 2022)

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

    Contact:
      Project page: http://repo.hu/projects/miniboxtk
      contact lead developer: http://www.repo.hu/projects/miniboxtk/contact.html
*/

#include <stdlib.h>
#include "cursor.h"


mbtk_mocu_t *mbtk_mocu_create_named(mbtk_display_t *display, mbtk_mocu_named_t name)
{
	if ((display == NULL) || (display->be == NULL) || (display->be->mocu_create_named == NULL))
		return NULL;

	return display->be->mocu_create_named(display, name);

}

mbtk_mocu_t *mbtk_mocu_create_pixmap(mbtk_display_t *display, int width, int height, unsigned const char *px, unsigned const char *mask, int hot_x, int hot_y)
{
	if ((display == NULL) || (display->be == NULL) || (display->be->mocu_create_pixmap == NULL))
		return NULL;

	return display->be->mocu_create_pixmap(display, width, height, px, mask, hot_x, hot_y);
}

void mbtk_mocu_free_cursor(mbtk_display_t *display, mbtk_mocu_t *curs)
{
	if ((display == NULL) || (display->be == NULL) || (display->be->mocu_free_cursor == NULL))
		return;

	display->be->mocu_free_cursor(display, curs);
}

void mbtk_mocu_set_cursor(mbtk_display_t *display, mbtk_mocu_t *curs)
{
	if ((display == NULL) || (display->be == NULL) || (display->be->mocu_set_cursor == NULL))
		return;

	display->be->mocu_set_cursor(display, curs);
}
