/*  miniboxtk - small GUI toolkit/widget system
    Copyright (C) 2022  Tibor 'Igor2' Palinkas

    (Supported by NLnet NGI0 PET Fund in 2022)

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

    Contact:
      Project page: http://repo.hu/projects/miniboxtk
      contact lead developer: http://www.repo.hu/projects/miniboxtk/contact.html
*/

#ifndef LIBMBTK_WIDGET_ARROW_H
#define LIBMBTK_WIDGET_ARROW_H

#include <libmbtk/widget.h>
#include <libmbtk/widget_inlines.h>

/* Draws an arrow on transparent background. Used for combo box dropdow,
   sumenu indication. Implemented as a separate widget so it is easier to
   override from style. */

typedef enum mbtk_arrow_dir_e {
	MBTK_ARROW_UP,
	MBTK_ARROW_DOWN,
	MBTK_ARROW_LEFT,
	MBTK_ARROW_RIGHT
} mbtk_arrow_dir_t;

typedef struct mbtk_arrow_s {
	mbtk_widget_t w;
	mbtk_arrow_dir_t dir;
} mbtk_arrow_t;

mbtk_arrow_t *mbtk_arrow_new(mbtk_arrow_t *caller_alloced, mbtk_arrow_dir_t dir);

MBTK_WIDGET_INLINES(arrow)

#endif
