/*  miniboxtk - small GUI toolkit/widget system
    Copyright (C) 2022  Tibor 'Igor2' Palinkas

    (Supported by NLnet NGI0 PET Fund in 2022)

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

    Contact:
      Project page: http://repo.hu/projects/miniboxtk
      contact lead developer: http://www.repo.hu/projects/miniboxtk/contact.html
*/

#include <assert.h>
#define MBTK_NO_INCLUDE_WIDGETS
#include <libmbtk/widget.h>
#include <libmbtk/widget_imp.h>
#include <libmbtk/widget/button.h>
#include <libmbtk/widget/hand_toggle.h>

#include <libmbtk/widget/tbutton.h>

mbtk_tbutton_t *mbtk_tbutton_new(mbtk_tbutton_t *caller_alloced)
{
	mbtk_tbutton_t *res = (mbtk_tbutton_t *)mbtk_button_new((mbtk_button_t *)caller_alloced);
	assert(sizeof(mbtk_button_t) == sizeof(mbtk_tbutton_t));
	mbtk_handler_toggle_install(&res->w);
	return res;
}

mbtk_tbutton_t *mbtk_tbutton_new_with_label(const char *str)
{
	mbtk_tbutton_t *res = (mbtk_tbutton_t *)mbtk_button_new_with_label(str);
	assert(sizeof(mbtk_button_t) == sizeof(mbtk_tbutton_t));
	mbtk_handler_toggle_install(&res->w);
	return res;
}

mbtk_tbutton_t *mbtk_tbutton_new_with_widget(mbtk_tbutton_t *caller_alloced, mbtk_widget_t *child)
{
	mbtk_tbutton_t *res = (mbtk_tbutton_t *)mbtk_button_new_with_widget((mbtk_button_t *)caller_alloced, child);
	assert(sizeof(mbtk_button_t) == sizeof(mbtk_tbutton_t));
	mbtk_handler_toggle_install(&res->w);
	return res;
}

mbtk_widget_t *mbtk_tbutton_set_child(mbtk_tbutton_t *parent, mbtk_widget_t *w)
{
	return mbtk_button_set_child((mbtk_button_t *)parent, w);
}

void mbtk_tbutton_callback_toggle(mbtk_tbutton_t *b, mbtk_event_handled_t (*cb)(mbtk_widget_t *w, mbtk_kw_t id, void *user_data), void *user_data)
{
	mbtk_kw_t kw_toggled;
	mbtk_kw_cache(kw_toggled, "toggled");
	mbtk_callback_set_noarg(&b->w, kw_toggled, cb, user_data);
}
