/*  miniboxtk - small GUI toolkit/widget system
    Copyright (C) 2022  Tibor 'Igor2' Palinkas

    (Supported by NLnet NGI0 PET Fund in 2022)

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

    Contact:
      Project page: http://repo.hu/projects/miniboxtk
      contact lead developer: http://www.repo.hu/projects/miniboxtk/contact.html
*/

#ifndef LIBMBTK_WIDGET_INLINES
#define LIBMBTK_WIDGET_INLINES

/* API: widget implementation helper: create widget-specific property sets */

#include <libmbtk/config.h>
#include <libmbtk/widget.h>

#define MBTK_WIDGET_INLINES(name) \
	MBTK_INLINE void mbtk_ ## name ## _set_align(mbtk_ ## name ## _t *W, hvbox_align_t a) { mbtk_widget_set_align(&W->w, a); } \
	MBTK_INLINE void mbtk_ ## name ## _set_span(mbtk_ ## name ## _t *W, hvbox_span_t s) { mbtk_widget_set_span(&W->w, s); } \
	MBTK_INLINE void mbtk_ ## name ## _set_alt_span(mbtk_ ## name ## _t *W, hvbox_span_t s) { mbtk_widget_set_alt_span(&W->w, s); } \
	MBTK_INLINE void mbtk_ ## name ## _set_padding(mbtk_ ## name ## _t *W, int p) { mbtk_widget_set_padding(&W->w, p); } \
	MBTK_INLINE void mbtk_ ## name ## _set_spacing(mbtk_ ## name ## _t *W, int s) { mbtk_widget_set_spacing(&W->w, s); } \
	MBTK_INLINE void mbtk_ ## name ## _set_activated(mbtk_ ## name ## _t *W, mbtk_bool_t a) { mbtk_widget_set_activated(&W->w, a); } \
	MBTK_INLINE void mbtk_ ## name ## _set_minsize(mbtk_ ## name ## _t *W, long w, long h) { mbtk_widget_set_minsize(&W->w, w, h); } \
	MBTK_INLINE int mbtk_ ## name ## _style_set_prop(mbtk_ ## name ## _t *dst, mbtk_kw_t key, mbtk_arg_t value) { return mbtk_widget_style_set_prop(&dst->w, key, value); } \
	MBTK_INLINE void mbtk_ ## name ## _destroy(mbtk_ ## name ## _t *W) { mbtk_widget_destroy(&W->w); } \
	MBTK_INLINE void mbtk_ ## name ## _callback_pre_destroy(mbtk_ ## name ## _t *W, mbtk_event_handled_t (*cb)(mbtk_widget_t *w, mbtk_kw_t id, void *user_data), void *user_data) { mbtk_widget_callback_pre_destroy(&W->w, cb, user_data); }


#endif
